--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_pkt.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_pkt.h	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,914 @@
+/* name: mausb_pkt.h 
+ * description: library of MA USB packet structures 
+ * 
+ * This file is provided under a dual BSD/GPLv2 license. When using or 
+ * redistributing this file, you may do so under either license. 
+ * 
+ * GPL LICENSE SUMMARY 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * This program is free software; you can redistribute it and/or modify it 
+ * under the terms of version 2 of the GNU General Public License as published 
+ * by the Free Software Foundation. 
+ * 
+ * This program is distributed in the hope that it will be useful, but 
+ * WITHOUT ANY WARRANTY; without even the implied warranty of 
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
+ * General Public License for more details. 
+ * 
+ * Contact Information: 
+ * Sean Stalley, sean.stalley [at] intel 
+ * Stephanie Wallick, stephanie.s.wallick [at] intel 
+ * 2111 NE 25th Avenue 
+ * Hillsboro, Oregon 97124 
+ * 
+ * BSD LICENSE 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * Redistribution and use in source and binary forms, with or without 
+ * modification, are permitted provided that the following conditions 
+ * are met: 
+ * 
+ * Redistributions of source code must retain the above copyright 
+ notice, this list of conditions and the following disclaimer. 
+ * Redistributions in binary form must reproduce the above copyright 
+ notice, this list of conditions and the following disclaimer in 
+ the documentation and/or other materials provided with the 
+ distribution. 
+ * Neither the name of Intel Corporation nor the names of its 
+ contributors may be used to endorse or promote products derived 
+ from this software without specific prior written permission. 
+ 
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
+ * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
+ * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
+ * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
+ */ 
+ 
+#ifndef __MAUSB_PKT_H__ 
+#define __MAUSB_PKT_H__ 
+ 
+#include <linux/usb/ch9.h> 
+#include "mausb_msapi.h" 
+ 
+#ifdef DEBUG 
+#define mapkt_dbg(format, arg...) \ 
+ printk(KERN_DEBUG format, ##arg) 
+#else 
+#define mapkt_dbg(format, arg...) 
+#endif 
+ 
+#define mapkt_warn(format, arg...) \ 
+ printk(KERN_WARNING format, ##arg) 
+ 
+#define mapkt_err(format, arg...) \ 
+ printk(KERN_ERR format, ##arg) 
+ 
+/* protocol Version, per section 6.2.1.1 */ 
+#define MAUSB_VERSION_1_0 0x0 
+#define MAUSB_VERSION_MASK 0x0F 
+ 
+/* packet Flags, per section 6.2.1.2 */ 
+#define MAUSB_PKT_FLAG_MASK 0xF0 
+#define MAUSB_PKT_FLAG_HOST (1 << 4) 
+#define MAUSB_PKT_FLAG_RETRY (1 << 5) 
+#define MAUSB_PKT_FLAG_TIMESTAMP (1 << 6) 
+ 
+/* packet Types, per section 6.2.1.3 */ 
+#define MAUSB_PKT_TYPE_MASK 0xC0 
+#define MAUSB_PKT_TYPE_MGMT (0 << 6) 
+#define MAUSB_PKT_TYPE_CTRL (1 << 6) 
+#define MAUSB_PKT_TYPE_DATA (2 << 6) 
+ 
+/* packet Subtypes, section 6.2.1.3 */ 
+#define MAUSB_SUBTYPE_MASK 0x3F 
+ 
+enum mausb_pkt_type { 
+ /* Management packets */ 
+ CapReq = 0x00 | MAUSB_PKT_TYPE_MGMT, 
+ CapResp , /* 1 */ 
+ USBDevHandleReq , /* 2 */ 
+ USBDevHandleResp , /* 3 */ 
+ 
+ EPHandleReq , /* 4 */ 
+ EPHandleResp , /* 5 */ 
+ EPActivateReq , /* 6 */ 
+ EPActivateResp , /* 7 */ 
+ EPInactivateReq , /* 8 */ 
+ EPInactivateResp , /* 9 */ 
+ EPResetReq , /* 10 */ 
+ EPResetResp , /* 11 */ 
+ EPClearTransferReq , /* 12 */ 
+ EPClearTransferResp , /* 13 */ 
+ EPHandleDeleteReq , /* 14 */ 
+ EPHandleDeleteResp , /* 15 */ 
+ 
+ DevResetReq , /* 16 */ 
+ DevResetResp , /* 17 */ 
+ ModifyEP0Req , /* 18 */ 
+ ModifyEP0Resp , /* 19 */ 
+ SetUSBDevAddrReq , /* 20 */ 
+ SetUSBDevAddrResp , /* 21 */ 
+ UpdateDevReq , /* 22 */ 
+ UpdateDevResp , /* 23 */ 
+ USBDevDisconnectReq , /* 24 */ 
+ USBDevDisconnectResp , /* 25 */ 
+ 
+ USBSuspendReq , /* 26 */ 
+ USBSuspendResp , /* 27 */ 
+ USBResumeReq , /* 28 */ 
+ USBResumeResp , /* 29 */ 
+ RemoteWakeReq , /* 30 */ 
+ RemoteWakeResp , /* 31 */ 
+ PingReq , /* 32 */ 
+ PingResp , /* 33 */ 
+ DevDisconnectReq , /* 34 */ 
+ DevDisconnectResp , /* 35 */ 
+ DevInitDisconnectReq , /* 36 */ 
+ DevInitDisconnectResp , /* 37 */ 
+ SyncReq , /* 38 */ 
+ SyncResp , /* 39 */ 
+ CancelTransferReq , /* 40 */ 
+ CancelTransferResp , /* 41 */ 
+ EPOpenStreamReq , /* 42 */ 
+ EPOpenStreamResp , /* 43 */ 
+ EPCloseStreamReq , /* 44 */ 
+ EPCloseStreamResp , /* 45 */ 
+ USBDevResetReq , /* 46 */ 
+ USBDevResetResp , /* 47 */ 
+ 
+ DevNotificationReq , /* 48 */ 
+ DevNotificationResp , /* 49 */ 
+ EPSetKeepAliveReq , /* 50 */ 
+ EPSetKeepAliveResp , /* 51 */ 
+ GetPortBWReq , /* 52 */ 
+ GetPortBWResp , /* 53 */ 
+ SleepReq , /* 54 */ 
+ SleepResp , /* 55 */ 
+ WakeReq , /* 56 */ 
+ WakeResp , /* 57 */ 
+ 
+ /* Vendor-Specific Management Packets */ 
+ VendorSpecificReq = 0x3E | MAUSB_PKT_TYPE_MGMT, 
+ VendorSpecificResp , 
+ 
+ /* Control Packets */ 
+ TransferSetupReq = 0x00 | MAUSB_PKT_TYPE_CTRL, 
+ TransferSetupResp , 
+ TransferTearDownConf , 
+ 
+ /* Data Packets */ 
+ TransferReq = 0x00 | MAUSB_PKT_TYPE_DATA, 
+ TransferResp = 0x01 | MAUSB_PKT_TYPE_DATA, 
+ TransferAck , 
+ IsochTransferReq , 
+ IsochTransferResp 
+}; 
+ 
+/* Endpoint Handle Fields, per section 6.2.1.5 */ 
+struct __packed mausb_ep_handle { 
+ union { 
+ struct { 
+#ifdef __LITTLE_ENDIAN_BITFIELD 
+ __le16 dir:1; /**< Direction Field */ 
+ __le16 ep_num:4; /**< Endpoint Number */ 
+ __le16 dev_addr:7; /**< USB Device Address */ 
+ __le16 bus_num:4; /**< Bus Number */ 
+#else 
+ __le16 bus_num:4; /**< Bus Number */ 
+ __le16 dev_addr:7; /**< USB Device Address */ 
+ __le16 ep_num:4; /**< Endpoint Number */ 
+ __le16 dir:1; /**< Direction Field */ 
+#endif 
+ }; 
+ __u16 handle; 
+ }; 
+}; 
+ 
+#define MAUSB_VIRTUAL_BUS_NUM 15 
+ 
+/* The least significant bit of the packet is only set to 1 in */ 
+/* response packets. */ 
+#define MAUSB_PKT_RESP_FLAG 0x01 
+ 
+/** Status Code Values, per section 6.2.1.8, Table 6 */ 
+enum mausb_pkt_status { 
+ SUCCESS = 0, 
+ UNSUCCESSFUL = 128, 
+ INVALID_MA_USB_SESSION_STATE, 
+ INVALID_DEVICE_HANDLE, 
+ INVALID_EP_HANDLE, 
+ INVALID_EP_HANDLE_STATE, 
+ INVALID_REQUEST, 
+ MISSING_SEQUENCE_NUMBER, 
+ TRANSFER_PENDING, 
+ TRANSFER_EP_STALL, 
+ TRANSFER_SIZE_ERROR, 
+ TRANSFER_DATA_BUFFER_ERROR, 
+ TRANSFER_BABBLE_DETECTED, 
+ TRANSFER_TRANSACTION_ERROR, 
+ TRANSFER_SHORT_TRANSFER, 
+ TRANSFER_CANCELLED, 
+ INSUFFICENT_RESOURCES, 
+ NOT_SUFFICENT_BANDWIDTH, 
+ INTERNAL_ERROR, 
+ DATA_OVERRUN, 
+ DEVICE_NOT_ACCESSED, 
+ BUFFER_OVERRUN, 
+ BUSY, 
+ DROPPED_PACKET, 
+ ISOC_TIME_EXPIRED, 
+ ISOCH_TIME_INVALID, 
+ NO_USB_PING_RESPONSE, 
+ NOT_SUPPORTED, 
+ REQUEST_DENIED 
+}; 
+ 
+/* Status codes NO_ERROR and SUCCESS are interchangeable. */ 
+#define NO_ERROR SUCCESS 
+ 
+/* MA USB packet header size, per 6.2.1 */ 
+#define MAUSB_PKT_HEADER_SIZE 12 
+ 
+/** common header fields, per section 6.2.1 */ 
+struct __packed mausb_pkt_common { 
+ /* DWORD 0 */ 
+ __u8 ver_flags; /**< MA USB version & Flags */ 
+ enum mausb_pkt_type pkt_type:8; /**< type and subtype */ 
+ __le16 length; /**< length (in bytes) */ 
+ /* DWORD 1 */ 
+ union { 
+ struct mausb_ep_handle ep_handle; /**< Endpoint Handle */ 
+ __le16 dev_handle;/**< Device Handle */ 
+ }; 
+ __u8 ma_dev_addr;/**< MA USB Device Address */ 
+ __u8 mass_id; /**< MA USB Service Set (MSS) id*/ 
+ /* DWORD 2 */ 
+ enum mausb_pkt_status pkt_status:8; /**< packet status code */ 
+}; 
+ 
+/** MA USB Global Time, per section 6.6.1 */ 
+struct __packed mausb_time { 
+#ifdef __LITTLE_ENDIAN_BITFIELD 
+ /** value of delta field in ITP, defined in USB 3.1 spec. */ 
+ __le32 delta:13; 
+ /** nominal bus interval, Indicates USB microframe number */ 
+ __le32 nom_bus_itvl:19; 
+#else 
+ __le32 nom_bus_itvl:19; 
+ __le32 delta:13; 
+#endif 
+}; 
+ 
+#define MAUSB_PKT_WSE_NO_DOCK 0 
+#define MAUSB_PKT_WSE_DOCK_2_0 1 
+#define MAUSB_PKT_WSE_DOCK_3_0 2 
+ 
+/** 
+ * MAUSB Device Functionality Support Speed 
+ * 
+ * mausb_dev_bfs_speed are used for the bFunctionalitySupport field. 
+ * Note that they are different values than usb_device_speed. 
+ */ 
+enum mausb_dev_bfs_speed { 
+ MAUSB_LOW_SPEED = 0, 
+ MAUSB_FULL_SPEED, 
+ MAUSB_HIGH_SPEED, 
+ MAUSB_SUPER_SPEED, 
+ MAUSB_SUPER_SPEED_PLUS, 
+ MAUSB_INVALID_SPEED 
+}; 
+ 
+/* MA USB Capability Request fields, per 6.3.2, table 7 */ 
+struct __packed mausb_CapReq_flds { 
+#ifdef __LITTLE_ENDIAN_BITFIELD 
+ __le32 max_mgmt_reqs:12; /**< max # of outstanding mgmt reqs to host */ 
+ __le32 rsvd:20; /**< reserved */ 
+#else 
+ __le32 rsvd:20; /**< reserved */ 
+ __le32 max_mgmt_reqs:12; /**< max # of outstanding mgmt reqs to host */ 
+#endif 
+}; 
+ 
+#define MAUSB_DEV_TYPE_INTEGRATED 0 
+#define MAUSB_DEV_TYPE_HS_HUB 1 
+#define MAUSB_DEV_TYPE_SS_HUB 2 
+ 
+/** MA USB Capability Response fields, per 6.3.3, table 12 */ 
+struct __packed mausb_CapResp_flds { 
+ __le16 num_ep; /**< number of endpoints */ 
+ __u8 num_dev; /**< number of devices */ 
+#ifdef __LITTLE_ENDIAN_BITFIELD 
+ __u8 num_stream:5; /**< 2^this value = max streams supported */ 
+ __u8 dev_type:3; /**< 0 = not a hub, 1 = 2.0 hub, 2 = 3.1 hub */ 
+#else 
+ __u8 dev_type:3; /**< 0 = not a hub, 1 = 2.0 hub, 2 = 3.1 hub */ 
+ __u8 num_stream:5; /**< 2^this value = max streams supported */ 
+#endif 
+ 
+#ifdef __LITTLE_ENDIAN_BITFIELD 
+ __le32 desc_count:8; /**< descriptors count */ 
+ __le32 desc_length:24; /**< total length of descriptors */ 
+#else 
+ __le32 desc_length:24; /**< total length of descriptors */ 
+ __le32 desc_count:8; /**< descriptors count */ 
+#endif 
+ 
+ __le16 max_tx_reqs; /**< max # of outstanding transfer reqs */ 
+ 
+#ifdef __LITTLE_ENDIAN_BITFIELD 
+ __le16 max_mgmt_reqs:12;/**< max # of outstanding management reqs */ 
+ __le16 rsvd:4; /**< reserved */ 
+#else 
+ __le16 rsvd:4; /**< reserved */ 
+ __le16 max_mgmt_reqs:12;/**< max # of outstanding management reqs */ 
+#endif 
+}; 
+ 
+/** MA USB Device Capability Type Values, per 6.3.3, table 14 */ 
+enum mausb_dev_cap_type { 
+ MAUSB_DEV_CAP_SPEED = 0, 
+ MAUSB_DEV_CAP_POUT, 
+ MAUSB_DEV_CAP_ISO, 
+ MAUSB_DEV_CAP_SYNC, 
+ MAUSB_DEV_CAP_CONT_ID, 
+ MAUSB_DEV_CAP_LINK_SLEEP 
+}; 
+ 
+/** Speed Capability Speed Enumeration, per 6.3.3.1 */ 
+enum mausb_dev_cap_speed_speed { 
+ MAUSB_DEV_CAP_SPEED_LOW = 0, 
+ MAUSB_DEV_CAP_SPEED_FULL, 
+ MAUSB_DEV_CAP_SPEED_HIGH, 
+ MAUSB_DEV_CAP_SPEED_SUPER, 
+ MAUSB_DEV_CAP_SPEED_SS_PLUS 
+}; 
+ 
+/** Speed Capability Descriptor, per 6.3.3.1 */ 
+struct __packed mausb_dev_cap_speed { 
+ /* DWORD n+0 */ 
+ __u8 rsvd_0:4; /**< Reserved */ 
+ enum mausb_dev_cap_speed_speed speed:4; /**< USB Device Speed */ 
+ __u8 rsvd_1:4; /**< Reserved */ 
+ __u8 lse:2; /**< Lane Speed Exponent */ 
+ __u8 st:2; /**< Sublink Type */ 
+ 
+ /* DWORD n+1 */ 
+ __u8 rsvd_2:2; /**< Reserved */ 
+ __u8 lane_count:4; /**< Lane Count */ 
+ __u8 link_protocol:2; /**< Link Protocol */ 
+ __le16 lsm; /**< Lane Speed Mantissa */ 
+}; 
+ 
+#define MAUSB_DEV_CAP_SPEED_LENGTH 7 
+ 
+/** P-Managed OUT Capabilities Descriptor, per 6.3.3.2 */ 
+struct __packed mausb_dev_cap_pout { 
+ __u8 elastic_buf_cap:1; /**< Elastic Buffer Capability */ 
+ __u8 drop_notif:1; /**< Drop Notification */ 
+ __u8 rsvd:6; /**< Reserved */ 
+ 
+}; 
+ 
+#define MAUSB_DEV_CAP_POUT_LENGTH 3 
+ 
+/** Isochronous Capabilities Descriptor, per 6.3.3.3 */ 
+struct __packed mausb_dev_cap_iso { 
+ __u8 iso_alignment:1; /**< Isochronous Payload Alignment */ 
+ __u8 rsvd:7; /**< Reserved */ 
+}; 
+ 
+#define MAUSB_DEV_CAP_ISO_LENGTH 3 
+ 
+/** Synchronization Capabilities Descriptor, per 6.3.3.4 */ 
+struct __packed mausb_dev_cap_sync { 
+ __u8 media_time_avail:1; /**< Media Time Available */ 
+ __u8 timestamp_req:1; /**< Timestamp Request */ 
+ __u8 rsvd:6; /**< Reserved */ 
+}; 
+ 
+#define MAUSB_DEV_CAP_SYNCH_LENGTH 3 
+ 
+/** Container ID Capability Descriptor, per 6.3.3.5 */ 
+struct __packed mausb_dev_cap_cont_id { 
+ long long int cont_id_upper; /**< 64 msb of Container ID */ 
+ long long int cont_id_lower; /**< 64 lsb of Container ID */ 
+}; 
+ 
+#define MAUSB_DEV_CAP_CONT_ID_LENGTH 18 
+ 
+/** Link Sleeo Capability Descriptor, per 6.3.3.6 */ 
+struct __packed mausb_dev_cap_link_sleep { 
+ __u8 link_sleep_cap:1; /**< Link Sleep Capable */ 
+ __u8 rsvd:7; /**< Reserved */ 
+}; 
+ 
+#define MAUSB_DEV_CAP_LINK_SLEEP_LENGTH 3 
+ 
+/** MA Device Capability Descriptor */ 
+struct __packed mausb_dev_cap_desc { 
+ /* common descriptor fields */ 
+ __u8 length; /**< Descriptor length */ 
+ enum mausb_dev_cap_type cap_type:8; /**< Capability type */ 
+ 
+ /* Descriptor-specific format */ 
+ union { 
+ struct mausb_dev_cap_speed speed; 
+ struct mausb_dev_cap_pout pout; 
+ struct mausb_dev_cap_iso iso; 
+ struct mausb_dev_cap_sync sync; 
+ struct mausb_dev_cap_cont_id cont_id; 
+ struct mausb_dev_cap_link_sleep link_sleep; 
+ }; 
+}; 
+ 
+/** USB Device Handle Request fields, per 6.3.4, table 8 */ 
+struct __packed mausb_USBDevHandleReq_flds { 
+#ifdef __LITTLE_ENDIAN_BITFIELD 
+ __le32 usb_rt_str:20; /**< USB Route String, per USB3.0 Spec */ 
+ __le32 speed:4; /**< USB Device Speed */ 
+ __le32 rsvd_0:8; /**< reserved */ 
+ __le16 dock_hub; /**< dock hub device handle */ 
+ __le16 rsvd_1; /**< reserved */ 
+ __le16 parent_hub; /**< parent hub handle (if LS or HS) */ 
+ __u8 parent_hub_port:4; /**< parent hub port (if LS or HS) */ 
+ __u8 mtt:1; /**< multiple transaction translators */ 
+ __le16 rsvd_2:15; /**< reserved */ 
+ __u8 lse:2; /**< lane speed exponent */ 
+ __u8 st:2; /**< sublink type */ 
+ __u8 rsvd_3:2; /**< reserved */ 
+ __u8 lane_count:2; /**< lane count */ 
+ __u8 link_protocol:2; /**< link protocol */ 
+ __le16 lsm; /**< lane speed mantissa */ 
+ 
+#else 
+ __le16 lsm; /**< lane speed mantissa */ 
+ __u8 link_protocol:2; /**< link protocol */ 
+ __u8 lane_count:2; /**< lane count */ 
+ __u8 rsvd_3:2; /**< reserved */ 
+ __u8 st:2; /**< sublink type */ 
+ __u8 lse:2; /**< lane speed exponent */ 
+ __le16 rsvd_2:15; /**< reserved */ 
+ __u8 mtt:1; /**< multiple transaction translators */ 
+ __u8 parent_hub_port:4; /**< parent hub port (if LS or HS) */ 
+ __le16 parent_hub; /**< parent hub handle (if LS or HS) */ 
+ __le16 rsvd_1; /**< reserved */ 
+ __le16 dock_hub; /**< dock hub device handle */ 
+ __le32 rsvd_0:8; /**< reserved */ 
+ __le32 speed:4; /**< USB Device Speed */ 
+ __le32 usb_rt_str:20; /**< USB Route String, per USB3.0 Spec */ 
+#endif 
+}; 
+ 
+/* maximum number of EPs in a packet array */ 
+#define MAUSB_PKT_MAX_NUM_EP 31 
+ 
+/* EPHandleReq constants, per section 6.3.6 */ 
+#define MAUSB_EP_REQ_SIZE 8 
+#define MAUSB_EP_REQ_PADDING (MAUSB_EP_REQ_SIZE - USB_DT_ENDPOINT_SIZE) 
+#define MAUSB_SS_EP_REQ_SIZE 16 
+#define MAUSB_SS_EP_REQ_PADDING (MAUSB_SS_EP_REQ_SIZE - \ 
+ (USB_DT_ENDPOINT_SIZE + USB_DT_SS_EP_COMP_SIZE)) 
+ 
+/** packed USB endpoint descriptor */ 
+struct __packed mausb_ep_req { 
+ unsigned char ep_des[USB_DT_ENDPOINT_SIZE]; 
+ unsigned char padding[MAUSB_EP_REQ_PADDING]; 
+}; 
+ 
+/** packed SuperSpeed USB endpoint descriptor */ 
+struct __packed mausb_ss_ep_req { 
+ unsigned char ep_des[USB_DT_ENDPOINT_SIZE]; 
+ unsigned char ss_ep_comp_des[USB_DT_SS_EP_COMP_SIZE]; 
+ unsigned char padding[MAUSB_SS_EP_REQ_PADDING]; 
+}; 
+ 
+/** Endpoint Handle Request fields, per 6.3.6, Tables 10 & 11 */ 
+struct __packed mausb_EPHandleReq_flds { 
+#ifdef __LITTLE_ENDIAN_BITFIELD 
+ __le32 num_ep_des:5; /**< number of EP descriptors in the packet */ 
+ __le32 size_ep_des:6; /**< size of EP descriptors (in bytes) */ 
+ __le32 rsvd:21; /**< reserved */ 
+#else 
+ __le32 rsvd:21; 
+ __le32 size_ep_des:6; 
+ __le32 num_ep_des:5; 
+#endif 
+ /** array of endpoint descriptors (Standard or SuperSpeed) */ 
+ union { 
+ struct mausb_ep_req ep_des[MAUSB_PKT_MAX_NUM_EP] 
+ __aligned(4); 
+ struct mausb_ss_ep_req ss_ep_des[MAUSB_PKT_MAX_NUM_EP] 
+ __aligned(4); 
+ /* TODO: structure for USB 3.1 devices with ISO endpoints */ 
+ }; 
+}; 
+ 
+ 
+/** WEP Descriptor format, per 6.3.7, table 13 */ 
+struct __packed mausb_ep_des { 
+ struct mausb_ep_handle ep_handle; /**< requested endpoint handle */ 
+#ifdef __LITTLE_ENDIAN_BITFIELD 
+ __le16 dir:1; /**< direction */ 
+ __le16 iso:1; /**< isochronous */ 
+ __le16 l_man:1; /**< L-managed transfers */ 
+ __le16 valid:1; /**< valid handle bit */ 
+ __le16 rsvd_0:12; /**< reserved */ 
+#else 
+ __le16 rsvd_0:12; /**< reserved */ 
+ __le16 valid:1; /**< valid handle bit */ 
+ __le16 l_man:1; /**< L-managed transfers */ 
+ __le16 iso:1; /**< isochronous */ 
+ __le16 dir:1; /**< direction */ 
+#endif 
+ __le16 ccu; /**< credit consumption unit */ 
+ __le16 rsvd_1; /**< reserved */ 
+ __le32 buffer_size; /**< buffer size (in bytes) */ 
+ __le16 iso_prog_dly; /**< max iso programming delay (in uSec) */ 
+ __le16 iso_resp_dly; /**< max iso response delay (in uSec) */ 
+}; 
+ 
+/** Endpoint Handle Response fields, per 6.3.7, Tables 12 & 13 */ 
+struct __packed mausb_EPHandleResp_flds { 
+#ifdef __LITTLE_ENDIAN_BITFIELD 
+ __le32 num_ep_des:5; /**< number of EP descriptors in this packet */ 
+ __le32 rsvd:27; /**< reserved */ 
+#else 
+ __le32 rsvd:27; /**< reserved */ 
+ __le32 num_ep_des:5; /**< number of EP descriptors in this packet */ 
+#endif 
+ struct mausb_ep_des ep_des[MAUSB_PKT_MAX_NUM_EP]; 
+}; 
+ 
+/** Endpoint Handle Delete fields, per 6.3.16 & 6.3.17, Tables 37 & 38 */ 
+/* 
+ * Note: both the request and response packets are in the same format. 
+ * The the request contains all the handles to delete, and the 
+ * response indicates how many were deleted. 
+ */ 
+struct __packed mausb_EPHandleDelete_flds { 
+#ifdef __LITTLE_ENDIAN_BITFIELD 
+ __le32 num_ep:5; /**< number of EP descriptors */ 
+ __le32 rsvd:27; /**< reserved */ 
+#else 
+ __le32 rsvd:27; /**< reserved */ 
+ __le32 num_ep:5; /**< number of EP descriptors */ 
+#endif 
+ struct mausb_ep_handle ep_handle[MAUSB_PKT_MAX_NUM_EP]; 
+}; 
+ 
+/** Modify EP0 Request and Response fields, per 6.3.20-21, table 39 & 40 */ 
+struct __packed mausb_ModifyEP0_flds { 
+ /** Endpoint 0 handle for the device */ 
+ struct mausb_ep_handle ep_handle; 
+ union { 
+ __le16 max_pkt_size; /**< Maximum packet size for EP0 */ 
+ __le16 rsvd; /**< reserved */ 
+ }; 
+}; 
+ 
+/** Set USB Device Address Request fields, per 6.3.22, table 41 */ 
+struct __packed mausb_SetDevAddrReq_flds { 
+ __le16 resp_timeout; /**< time the device has to respond (in ms) */ 
+ __le16 rsvd; 
+}; 
+ 
+/** Set USB Device Address Response fields, per 6.3.23, table 42 */ 
+struct __packed mausb_SetDevAddrResp_flds { 
+#ifdef __LITTLE_ENDIAN_BITFIELD 
+ __le32 dev_addr:7; /**< USB Device Address from request */ 
+ __le32 rsvd:25; 
+#else 
+ __le32 rsvd:25; 
+ __le32 dev_addr:7; /**< USB Device Address from request */ 
+#endif 
+}; 
+ 
+/** Update Device Request fields, per 6.3.24, Table 28 */ 
+struct __packed mausb_UpdateDevReq_flds { 
+ __le16 max_exit_lat; /**< Max Exit Latency */ 
+#ifdef __LITTLE_ENDIAN_BITFIELD 
+ __u8 hub:1; /**< Hub flag, set to 1 if hub */ 
+ __u8 num_ports:4; /**< hub only, number of downward-facing ports */ 
+ __u8 mtt:1; /**< HS hub only, Multiple Transaction Translator */ 
+ __u8 ttt:2; /**< HS hub only, Transaction Think Time */ 
+ /**< 0 = at most 8 FS bit times */ 
+ /**< 1 = at most 16 FS bit times */ 
+ /**< 2 = at most 24 FS bit times */ 
+ /**< 3 = at most 32 FS bit times */ 
+#else 
+ __u8 ttt:2; 
+ __u8 mtt:1; 
+ __u8 num_ports:4; 
+ __u8 hub:1; 
+#endif 
+}; 
+ 
+/** MAUSB Synchronization Request fields, per 6.3.40, Table 30 */ 
+struct __packed mausb_SynchReq_flds { 
+#ifdef __LITTLE_ENDIAN_BITFIELD 
+ __le16 td_valid:1; /**< Transmission Delay field valid */ 
+ __le16 rsvd:15; /**< reserved */ 
+#else 
+ __le16 rsvd:15; /**< reserved */ 
+ __le16 td_valid:1; /**< Transmission Delay field valid */ 
+#endif 
+ struct mausb_time timestamp; /**< MA USB Timestamp, per 6.5.1.11 */ 
+ __le32 tx_dly; /**< Transmission delay, per 6.5.1.12 */ 
+}; 
+ 
+/** Cancel Transfer Request fields, per 6.3.42, Table 31 */ 
+struct __packed mausb_CancelTransferReq_flds { 
+ struct mausb_ep_handle ep_handle; /**< Target Endpoint Handle */ 
+ __le16 stream_id; /**< Target stream ID */ 
+#ifdef __LITTLE_ENDIAN_BITFIELD 
+ __le32 req_id:8; /**< Target request ID */ 
+ __le32 rsvd:24; /**< reserved */ 
+#else 
+ __u32 rsvd:24; /**< reserved */ 
+ __u32 req_id:8; /**< Target request ID */ 
+#endif 
+}; 
+ 
+/** Cancel Transfer Response fields, per 6.3.43, Table 32 */ 
+struct __packed mausb_CancelTransferResp_flds { 
+ struct mausb_ep_handle ep_handle; 
+ __u16 stream_id; 
+ /** Cancellation status */ 
+ /** 0 = Cancel Error */ 
+ /** 1 = Cancel Sucess before any data was moved */ 
+ /** 2 = Cancel Sucess after some data was moved */ 
+ /** 3 = Transfer not found */ 
+ 
+#ifdef __LITTLE_ENDIAN_BITFIELD 
+ __le32 req_id:8; 
+ __le32 cancel_status:2; 
+ __le32 rsvd_0:22; 
+#else 
+ __le32 rsvd_0:22; 
+ __le32 cancel_status:2; 
+ __le32 req_id:8; 
+#endif 
+ /** Delivered Sequence Number */ 
+ /** For OUT Transfers only. Only valid if cancel_status = 2 */ 
+ /** Indicates last sequence number delivered to the device. */ 
+#ifdef __LITTLE_ENDIAN_BITFIELD 
+ __le32 deliv_seq_num:24; 
+ __le32 rsvd_1:8; 
+#else 
+ __le32 deliv_seq_num:24; 
+ __le32 rsvd_1:8; 
+#endif 
+ /** Delivered Byte Offset. Only valid if cancel_status = 2 */ 
+ __le32 deliv_byte_offset; 
+}; 
+ 
+/** Enpoint Open Stream Request fields, per 6.3.44, Table 33 */ 
+struct __packed mausb_EPOpenStreamReq_flds { 
+ struct mausb_ep_handle ep_handle; /**< Target bulk endpoint */ 
+ __le32 num_streams:17; /**< number of streams to be opened */ 
+ __le32 rsvd:7; 
+}; 
+ 
+/** Enpoint Inactivate Request fields, per 6.3.10, Table 30 */ 
+struct __packed mausb_EPInactivateReq_flds { 
+ __u8 num_ep_handles:5; /** number of ep handles included packet */ 
+ __u8 suspend_flg:1; /** indicates if issued due to suspension of */ 
+ /** included endpoints */ 
+ /** 0 = endpoints not suspended */ 
+ /** 1 = endpoints suspended */ 
+ __u32 rsvd:26; 
+ 
+ /** list of EP handles MA USB host is requesting to inactivate */ 
+ struct mausb_ep_handle ep_handle[MAUSB_PKT_MAX_NUM_EP]; 
+}; 
+ 
+/** Enpoint Inactivate Response fields, per 6.3.11, Table 33 */ 
+struct __packed mausb_EPInactivateResp_flds { 
+ __u8 num_ep_with_error:5; /** number of EP handles with */ 
+ /** unsuccessful inactivation */ 
+ /** should only be non-zero if */ 
+ /** packet status is not SUCCESS */ 
+ __u32 rsvd:27; 
+ 
+ /** list of EP handles whose inactivation failed */ 
+ struct mausb_ep_handle ep_handle[MAUSB_PKT_MAX_NUM_EP]; 
+}; 
+ 
+#define MAUSB_MGMT_MAX_TOKEN ((1 << 10) - 1) 
+#define MAUSB_MGMT_TOKEN_PAD_LEN 3 /* token + pad to DWORD */ 
+ 
+/** Management Packet fields, per 6.3.1 */ 
+struct __packed mausb_mgmt_pkt { 
+ struct mausb_pkt_common common; 
+#ifdef __LITTLE_ENDIAN_BITFIELD 
+ __le16 token:10; 
+ __le16 padding:6; /* for DWORD alignment */ 
+#else 
+ __le16 padding:6; /* for DWORD alignment */ 
+ __le16 token:10; 
+#endif 
+ __u8 padding_2; 
+ union { 
+ struct mausb_CapReq_flds cap_req; 
+ struct mausb_CapResp_flds cap_resp; 
+ struct mausb_USBDevHandleReq_flds usb_dev_handle_req; 
+ __le16 usb_dev_handle_resp; 
+ struct mausb_EPHandleReq_flds ep_handle_req; 
+ struct mausb_EPHandleResp_flds ep_handle_resp; 
+ struct mausb_EPHandleDelete_flds ep_handle_delete; 
+ struct mausb_ModifyEP0_flds modify_ep0_req; 
+ struct mausb_ModifyEP0_flds modify_ep0_resp; 
+ struct mausb_SetDevAddrReq_flds set_dev_addr_req; 
+ struct mausb_SetDevAddrResp_flds set_dev_addr_resp; 
+ struct mausb_UpdateDevReq_flds update_dev_req; 
+ struct mausb_SynchReq_flds synch_req; 
+ __le16 ep_close_stream_req; 
+ struct mausb_CancelTransferReq_flds cancel_transfer_req; 
+ struct mausb_CancelTransferResp_flds cancel_transfer_resp; 
+ struct mausb_EPOpenStreamReq_flds ep_open_stream_req; 
+ struct mausb_EPInactivateReq_flds ep_inactivate_req; 
+ struct mausb_EPInactivateResp_flds ep_inactivate_resp; 
+ 
+ /* TODO: add remaining management packet data */ 
+ 
+ }; 
+}; 
+ 
+/** Transfer Setup Request fields, per 6.4.1, Table 38 */ 
+struct __packed mausb_TransferSetupReq_flds { 
+ /** Identifies link type */ 
+ /** 0 = Reserved */ 
+ /** 1 = IEEE 802.11 link */ 
+ /** 2-255 = Reserved */ 
+ __u8 link_type; 
+ /** Connection ID data is dependant on Link Type */ 
+ union { 
+ /** for 802.11 links (link_type == 1) */ 
+ struct __packed { 
+ __u8 tid:4; /**< Traffic Identifier */ 
+ __u8 rsvd:4; 
+ } connection_id; 
+ }; 
+}; 
+ 
+/** Control Packet fields, per 6.4 */ 
+struct __packed mausb_ctrl_pkt { 
+ struct mausb_pkt_common common; 
+ struct mausb_TransferSetupReq_flds transfer_setup_req; 
+ __u8 padding; /* for header DWORD alignment */ 
+}; 
+ 
+#define MAUSB_PKT_EPS_UNASSIGNED 0 
+#define MAUSB_PKT_EPS_ACTIVE 1 
+#define MAUSB_PKT_EPS_INACTIVE 2 
+#define MAUSB_PKT_EPS_HALTED 3 
+ 
+#define MAUSB_PKT_TFLAG_ARQ (1 << 2) 
+#define MAUSB_PKT_TFLAG_NEG (1 << 3) 
+#define MAUSB_PKT_TFLAG_EOT (1 << 4) 
+#define MAUSB_PKT_TFLAG_TYPE_CTRL (0 << 5) 
+#define MAUSB_PKT_TFLAG_TYPE_ISOC (1 << 5) 
+#define MAUSB_PKT_TFLAG_TYPE_BULK (2 << 5) 
+#define MAUSB_PKT_TFLAG_TYPE_INT (3 << 5) 
+#define MAUSB_PKT_TFLAG_TYPE_MASK 0x60 
+ 
+#define MAUSB_PKT_SEQ_NUM_MASK 0x00FFFFFF 
+ 
+/** Fields common to all datapackets, per 6.5 */ 
+struct __packed mausb_dph { 
+ struct mausb_pkt_common common; 
+ __u8 eps_tflags; /**< EPS & T-Flags */ 
+#ifdef __LITTLE_ENDIAN_BITFIELD 
+ __le16 num_seg:12; 
+ __le16 iflags:4; 
+#else 
+ __le16 iflags:4; 
+ __le16 num_seg:12; 
+#endif 
+#ifdef __LITTLE_ENDIAN_BITFIELD 
+ __le32 seq_num:24; /**< Sequence Number */ 
+ __le32 req_id:8; /**< request ID */ 
+#else 
+ __le32 req_id:8; /**< request ID */ 
+ __le32 seq_num:24; /**< Sequence Number */ 
+#endif 
+ union { 
+ __le32 remaining_size_credit; 
+ __le32 present_time; 
+ }; 
+}; 
+ 
+/** Fields exclusive to isochronous data packets, per 6.5 */ 
+struct __packed mausb_iso_dph { 
+ struct mausb_dph data; 
+ __le32 wse_ts; /**< WSE Timestamp */ 
+ __le32 tx_dly; /**< Transmission Delay */ 
+}; 
+ 
+ 
+/* unless the urb contains scattergather buffers, a packet will 
+ * need at most 3 entries: 
+ * - 1 for the header 
+ * - 1 for the setup data 
+ * - 1 for the data buffer 
+ * 
+ */ 
+#define MAUSB_MS_PKT_ORIG_NENTS 4 
+ 
+/** 
+ * mausb_pkt structure 
+ * 
+ * Can be used to parse any type of MAUSB packet, regardless of contents. 
+ * If the packet type is known, this structure shouldn't be used. Instead, 
+ * a type-specific structure (ie: mausb_XXXX_pkt) should be used. 
+ * 
+ * @setup: setup data (control packets only) 
+ * @buffer: data buffer 
+ * @buffer_length: length of data buffer 
+ * @pkt_list: connects packet to other packets in a linked list 
+ * @kvec_list: kvec list 
+ * @nents: number of kvecs 
+ * @pkt: A compilation of all the buffers needed to be sent 
+ * across the medium. Used to pass packet to medium. 
+ * @orig_pkt: Original ms_pkt for this packet. Used for destructor. 
+ * If this packet originated from the MA driver, it will 
+ * point to the ms_pkt of this ma_pkt. If it came in from 
+ * the MS driver, it will point at the ms_pkt it sent 
+ * us. This is used by the ms_pkt_destructor, so we can 
+ * make sure we are pointing to the right ms_pkt. 
+ */ 
+struct mausb_pkt { 
+ union { 
+ struct mausb_pkt_common *common; 
+ struct mausb_mgmt_pkt *mgmt; 
+ struct mausb_ctrl_pkt *ctrl; 
+ struct mausb_dph *data; 
+ struct mausb_iso_dph *iso_data; 
+ }; 
+ 
+ struct usb_ctrlrequest *setup; 
+ void *buffer; 
+ u32 buffer_length; 
+ struct list_head pkt_list; 
+ struct kvec *kvec_list; 
+ int nents; 
+ struct ms_pkt pkt; 
+ struct ms_pkt *orig_pkt; 
+ void (*ms_pkt_destructor)(struct ms_pkt *pkt); 
+}; 
+ 
+enum mausb_pkt_buf_copy_dir { 
+ MAUSB_PKT_BUF_COPY_TO_KVEC = 0, 
+ MAUSB_PKT_BUF_COPY_FROM_KVEC 
+}; 
+ 
+void mausb_pkt_buf_copy_kvec(struct mausb_pkt *pkt, int buf_length, int offset, 
+ struct kvec *kv, int nents, 
+ enum mausb_pkt_buf_copy_dir dir); 
+ 
+/* function declarations */ 
+const char *mausb_type_to_string(enum mausb_pkt_type type); 
+int mausb_pkt_fill_ms_pkt(struct mausb_pkt *pkt, gfp_t mem_flags); 
+int mausb_pkt_header_length(struct mausb_pkt_common *header); 
+enum mausb_pkt_status mausb_errno_to_ma_status(int errno); 
+int mausb_to_urb_status(enum mausb_pkt_status pkt_status); 
+struct usb_endpoint_descriptor *mausb_ep_handle_req_get_ep_des( 
+ struct mausb_EPHandleReq_flds *req, int i); 
+int mausb_pkt_length(struct mausb_pkt *pkt); 
+struct mausb_pkt *mausb_alloc_pkt(enum mausb_pkt_type pkt_type, int *status, 
+ gfp_t memflags); 
+int mausb_generate_ms_pkt(struct mausb_pkt *pkt); 
+bool mausb_pkt_has_setup_data(struct mausb_dph *header); 
+struct mausb_pkt *ms_pkt_to_mausb_pkt(struct ms_pkt *ms_pkt); 
+struct mausb_pkt *mausb_pkt_from_ms_pkt(struct ms_pkt *ms_pkt, 
+ void (*ms_pkt_destructor)(struct ms_pkt *ms_pkt), 
+ gfp_t mem_flags); 
+int mausb_pkt_dmux(struct ms_pkt *ms_pkt, void *context); 
+void mausb_free_pkt(struct mausb_pkt *pkt); 
+bool mausb_pkt_resp(struct mausb_pkt *pkt); 
+struct mausb_dev_cap_desc *cap_desc_ptr_increment(struct mausb_mgmt_pkt *resp, 
+ int offset); 
+ 
+/* Helper functions for sequence number and request id wraparound */ 
+u32 mausb_seq_num_add(u32 seq_num, int val); 
+void mausb_increment_seq_num(u32 *seq_num); 
+bool mausb_seq_num_lt(u32 a, u32 b); 
+bool mausb_seq_num_lt_eq(u32 a, u32 b); 
+bool mausb_seq_num_gt_eq(u32 a, u32 b); 
+bool mausb_seq_num_gt(u32 a, u32 b); 
+u8 mausb_req_id_add(u8 req_id, int val); 
+bool mausb_req_id_lt(u8 a, u8 b); 
+bool mausb_req_id_gt(u8 a, u8 b); 
+bool mausb_req_id_gt_eq(u8 a, u8 b); 
+ 
+#endif 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_state.h linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_state.h
